import { ICompletionStage } from "./ICompletionStage";
import { Observable } from "rxjs";
import { CompletionContext } from "./CompletionContext";
import { CompletionError } from "./CompletionError";
export declare class CompletableObservable<T> implements ICompletionStage<T> {
    private observable;
    protected constructor(observable: Observable<T> | Observable<CompletionContext<T>>, hasContext?: boolean);
    thenApply<U>(func: (input: T) => U): ICompletionStage<U>;
    thenCompose<U>(func: (input: T) => ICompletionStage<U>): ICompletionStage<U>;
    thenAccept(consumer: (input: T) => void, handler?: (error: Error) => void): ICompletionStage<T>;
    exceptionally(func: (error: Error) => T): ICompletionStage<T>;
    subscribe(consumer?: (result: T) => void, handler?: (error: CompletionError) => void): void;
    static fromResult<U>(result: U): ICompletionStage<U>;
    static fromObservable<U>(observable: Observable<U>): ICompletionStage<U>;
    static fromPromise<U>(promise: Promise<U>): ICompletionStage<U>;
    static fromError<U>(error: Error): ICompletionStage<U>;
    static supplyAsync<U>(supplier: () => U): ICompletionStage<U>;
    private initializeObservable;
    private doApply;
    private doCompose;
    private doAccept;
    private doExceptionally;
    private toObservable;
}
