import { CompletionError } from "./CompletionError";
export declare class CompletionContext<T> {
    private result;
    private error;
    protected constructor(result: T, error: CompletionError);
    setResult(result: T): CompletionContext<T>;
    clearResult(): CompletionContext<T>;
    setError(error: CompletionError): CompletionContext<T>;
    clearError(): CompletionContext<T>;
    getResult(): T;
    getError(): CompletionError;
    hasResult(): boolean;
    hasError(): boolean;
    combine(other: CompletionContext<T>, combiner: (x: T, y: T) => T): CompletionContext<T>;
    accept(consumer: (context: CompletionContext<T>) => void): CompletionContext<T>;
    static empty<T>(): CompletionContext<T>;
    static ofResult<T>(result: T): CompletionContext<T>;
    static ofError<T>(error: CompletionError): CompletionContext<T>;
}
