"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiMap = void 0;
class MultiMap {
    imp;
    constructor() {
        this.imp = new Map();
    }
    put(key, value) {
        if (key == null)
            throw new Error("key is null");
        if (!this.imp.has(key))
            this.imp.set(key, new Array());
        this.imp.get(key).push(value);
        return this;
    }
    remove(key, value) {
        if (value) {
            if (this.imp.has(key)) {
                let values = this.imp.get(key);
                values.slice(values.indexOf(value), 1);
            }
        }
        else {
            if (this.imp.has(key))
                this.imp.delete(key);
        }
        return this;
    }
    get(key) {
        return this.imp.get(key);
    }
    getAt(key, index) {
        return this.imp.get(key)[index];
    }
    getCardinality(key) {
        return this.imp.get(key).length;
    }
    getKeys() {
        return Array.from(this.imp.keys());
    }
    getValues() {
        return Array.from(this.imp.values());
    }
    containsKey(key) {
        return this.imp.has(key);
    }
    containsValue(key, value) {
        if (this.containsKey(key))
            return this.get(key).includes(value);
        return false;
    }
}
exports.MultiMap = MultiMap;
//# sourceMappingURL=MultiMap.js.map